import { DocumentNode, GraphQLSchema } from "graphql";
import { EventBus, EventBusSubscriberCb, Publish } from "./EventBus";
import { EventBusPlugin } from "./VanillaEventBus";
export declare class MemoryEventBus implements EventBus {
    config: {
        publisher: {
            schema: GraphQLSchema;
        };
        subscriber: {
            cb: EventBusSubscriberCb;
            queries: DocumentNode;
            schema: GraphQLSchema;
        };
        plugins: EventBusPlugin[];
    };
    private eventEmitter;
    private bus;
    constructor(config: {
        publisher: {
            schema: GraphQLSchema;
        };
        subscriber: {
            cb: EventBusSubscriberCb;
            queries: DocumentNode;
            schema: GraphQLSchema;
        };
        plugins: EventBusPlugin[];
    });
    init: () => Promise<void>;
    publish: Publish;
    closeConsumer: () => Promise<void>;
    closePublisher: () => Promise<void>;
}
