"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoryEventBus = void 0;
const tslib_1 = require("tslib");
const events_1 = require("events");
const VanillaEventBus_1 = require("./VanillaEventBus");
class MemoryEventBus {
    constructor(config) {
        var _a;
        this.config = config;
        this.eventEmitter = new events_1.EventEmitter();
        this.init = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            yield this.bus.init();
        });
        this.publish = (args) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            yield this.bus.publish({
                topicName: args.topicName,
                data: args.data,
            });
        });
        this.closeConsumer = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            this.eventEmitter.removeAllListeners();
        });
        this.closePublisher = () => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            this.eventEmitter.removeAllListeners();
        });
        this.eventEmitter.setMaxListeners(100000);
        this.bus = new VanillaEventBus_1.VanillaEventBus({
            plugins: config.plugins,
            publisher: config.publisher
                ? {
                    schema: (_a = config.publisher) === null || _a === void 0 ? void 0 : _a.schema,
                    publish: (args) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
                        this.eventEmitter.emit(`message-${args.topicName}`, args.data);
                    }),
                }
                : undefined,
            subscriber: this.config.subscriber
                ? {
                    cb: this.config.subscriber.cb,
                    getSubscription: (topic, cb) => {
                        this.eventEmitter.on(`message-${topic}`, (data) => (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
                            yield cb(data);
                        }));
                    },
                    queries: this.config.subscriber.queries,
                    schema: this.config.subscriber.schema,
                }
                : undefined,
        });
    }
}
exports.MemoryEventBus = MemoryEventBus;
